Program Xonix;
Uses Crt,Graph;
Const N = 30;

type
 coord = record
   x,y: integer;
 end;

 TLine = Object
       kA1,kA2 : coord;
       Color   : Integer;
       procedure Draw;
       procedure Hide;
       procedure Next(Line:TLine);
       procedure ReColor;
       procedure Let(x1,y1,x2,y2:integer);
 end;

 pPoint = ^INTREC;
           INTREC = RECORD
                  L : TLine;
                  P : pPoint;
           End;

Var
   Po,PoB,PoE,Pon : pPoint;
   i,j: integer;
   Napr  : Integer;
   DH,DV : Coord;
   StepY, StepX : Integer;
   SDelay : Integer;
   code : Integer;

   grDriver : Integer;
   grMode   : Integer;

procedure ChangeStep;
Begin
      StepY := Trunc(Random(5)+1);
      StepX := Trunc(Random(5)+1);
End;

procedure TLine.Let(x1,y1,x2,y2: integer);
begin
 kA1.x:=x1;
 kA1.y:=y1;
 kA2.x:=x2;
 kA2.y:=y2;
end;

procedure TLine.ReColor;
begin
     Color := Random(15)+1;;
end;

procedure TLine.Next(Line:TLine);
Begin
      If (Line.kA1.X + StepX * DH.X > GetMaxX) Or
         (Line.kA1.X + StepX * DH.X < 0) Then
         Begin
              DH.X := (-1)*DH.X;
              ReColor;
              ChangeStep;
         End;

      If (Line.kA1.Y + StepY * DH.Y > GetMaxY) Or
         (Line.kA1.Y + StepY * DH.Y < 0) Then
         Begin
              DH.Y := (-1)*DH.Y;
              ReColor;
              ChangeStep;
         End;

      If (Line.kA2.X + StepX * DV.X > GetMaxX) Or
         (Line.kA2.X + StepX * DV.X < 0) Then
         Begin
              DV.X := (-1)*DV.X;
              ReColor;
              ChangeStep;
         End;

      If (Line.kA2.Y + StepY * DV.Y > GetMaxY) Or
         (Line.kA2.Y + StepY * DV.Y < 0) Then
         Begin
              DV.Y := (-1)*DV.Y;
              ReColor;
              ChangeStep;
         End;

      kA1.X := Line.kA1.X + StepX * DH.X;
      kA1.Y := Line.kA1.Y + StepY * DH.Y;
      kA2.X := Line.kA2.X + StepX * DV.X;
      kA2.Y := Line.kA2.Y + StepY * DV.Y;
End;

procedure TLine.Draw;
begin
 SetColor(Color);
 Line(kA1.X, kA1.Y, kA2.X, kA2.Y);
end;

procedure TLine.Hide;
begin
 SetColor(GetBkColor);
 Line(kA1.X, kA1.Y, kA2.X, kA2.Y);
end;

Procedure EGADRV; External;
{$L EGA.OBJ}

begin
     If ParamCount = 1 Then Val(ParamStr(1), SDelay, code)
                       Else SDelay := 10;
     ChangeStep;
     Randomize;

     If RegisterBGIDriver (@EGADRV) < 0 Then
     Begin
          WriteLn('訡  ॣ樨 ࠩ');
          Halt;
     End;
     grMode:=EGA;
     grDriver := EGALo;
     InitGraph(grDriver,grMode,'c:\tp\bgi\');

{-=    ६ =-}
  New(Po);
  Po^.L.Let( random(GetMaxX),
             random(GetMaxY),
             random(GetMaxX),
             random(GetMaxY));
  Po^.L.ReColor;
  Po^.P := Nil;
  PoB:=Po;
  PoE:=Po;

{-= ࠢ - 砩 =-}
  Napr := random(4);
  Case Napr Of
         0: Begin
                  DH.X := -1;
                  DV.X := -1;
                  DH.Y := 1;
                  DV.Y := 1;
            End;
         1: Begin
                  DH.X := 1;
                  DV.X := 1;
                  DH.Y := -1;
                  DV.Y := -1;
            End;
         2: Begin
                  DH.X := -1;
                  DV.X := -1;
                  DH.Y := -1;
                  DV.Y := -1;
            End;
         3: Begin
                  DH.X := 1;
                  DV.X := 1;
                  DH.Y := 1;
                  DV.Y := 1;
            End;
  End;

{-=   ⠫ ᪨ ६ =-}
  for i:=2 to N do begin
      New(Po);
      Po^.L:=PoE^.L;
      Po^.L.Next(Po^.L);
      Po^.P:=Nil;
      PoE^.P := Po;
      PoE := Po;
  end;

{-=  ,  ᮧ =-}
  Pon := PoB;
  While Pon<>Nil Do
  Begin
       Pon^.L.Draw;
       Pon := Pon^.P;
  End;

  repeat
{-----   -------------}
      Delay (SDelay);
      New(Po);
      Po^.L:=PoE^.L;
      Po^.L.Next(PoE^.L);
      Po^.P:=Nil;
      PoE^.P := Po;
      PoE := Po;
{----- 뢠 -------------}
      PoE^.L.Draw;
{----- 塞  -------------}
      Po:=PoB^.P;
      PoB^.L.Hide;
      Dispose(PoB);
      PoB := Po;
{------------------}
  until KeyPressed;

{-= 頥   祬  쥪 =-}
  While PoB<>Nil Do
  Begin
       Po:=PoB^.P;
       Po^.L.Hide;
       Dispose(PoB);
       PoB := Po;
  End;

  CloseGraph;
  readln;
End.